; sched.asm - This file is a part of NutsOS

; NutsOS
; Copyright (C) 2013  Free Software Foundation, Inc.

; NutsOS is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 3 of the License, or
; (at your option) any later version.

; NutsOS is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License along
; with NutsOS; If not, see <http://www.gnu.org/licenses/>.

; Valentin Verdier <valentin.verdier03@gmail.com>

[BITS 32]
[SECTION .text]

global _LoadContext, _SaveContex

_SaveContex:
	pushfd
	pushad
	push dword ds
	push dword es
	push dword fs
	push dword gs
	mov eax, [esp + 52] ; On retrouve l'adresse de retour empilée lors de l'appel
	push eax ; eip ret
	mov eax, esp
	add eax, 4
	ret



_LoadContext:
	mov esi, [esp + 4]

	mov ax, [esi + 48] ; cs
	cmp ax, 0x08
	je .kernMode
.userMode:
	mov ax, 0x18
	mov ss, ax
	mov esp, [esi + 64] ; Kstack_ptr
	push dword [esi + 58] ; ss
	push dword [esi + 36] ; esp
	jmp .next
.kernMode:
	mov ax, [esi + 58] ; ss
	mov ss, ax
	mov esp, [esi + 36] ; esp
.next:
	push dword [esi + 44] ; eflags
	push dword [esi + 48] ; cs
	push dword [esi + 40] ; eip
	push dword [esi + 8] ; eax
	push dword [esi + 12] ; ebx
	push dword [esi + 16] ; ecx
	push dword [esi + 20] ; edx
	push dword [esi + 24] ; esi
	push dword [esi + 28] ; edi
	push dword [esi + 32] ; ebp
	push dword [esi + 50] ; ds
	push dword [esi + 52] ; es
	push dword [esi + 54] ; fs
	push dword [esi + 56] ; gs

	mov eax, [esi + 60]
	mov cr3, eax

	pop gs
	pop fs
	pop es
	pop ds
	pop ebp
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax
	iret
